// Fungimol - an extensible system for designing atomic-scale objects.
// Copyright (C) 2000 Tim Freeman
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library in the file COPYING.txt; if not,
// write to the Free Software Foundation, Inc., 59 Temple Place -
// Suite 330, Boston, MA 02111-1307, USA
//
// The author can be reached by email at tim@fungible.com, or by
// paper mail at:
//
// Tim Freeman
// 381 North Fernwood Circle
// Sunnyvale, CA 94085-3059
//

#ifndef ConfigureAndRunConfiguration_h_included
#include "ConfigureAndRunConfiguration.h"
#endif

#ifndef Action_h_included
#include "Action.h"
#endif

#ifndef FactoryTable_h_included
#include "FactoryTable.h"
#endif

#ifndef MemoryUtil_h_included
#include "MemoryUtil.h"
#endif

#ifndef TypedFactory_h_included
#include "TypedFactory.h"
#endif

#ifndef TextConfigurationEditor_h_included
#include "TextConfigurationEditor.h"
#endif

#ifndef RecursiveSlotValue_h_included
#include "RecursiveSlotValue.h"
#endif

#ifndef myassert_h_included
#include "myassert.h"
#endif

namespace {
  class ConfigureAndRun
    : public TypedFactory <ConfigureAndRunConfiguration, Action>
  {
  public:
    ConfigureAndRun ()
      : TypedFactory <ConfigureAndRunConfiguration, Action> ("ConfigureAndRun")
    {}
    SP<ConfigureAndRunConfiguration> typedDefaultConfiguration () const {
      return NEW (ConfigureAndRunConfiguration ("Action"));
    }
    SP<Action> makeIt (ConfigureAndRunConfiguration *carc) const {
      TextConfigurationEditor::edit (carc->getRSV()->getConfiguration());
      SP<ActionConfiguration> ac = 
	dynamic_cast <ActionConfiguration *>
	(&*carc->getRSV()->getConfiguration());
      assert (ac);
      ac->setTopLevel (carc->getTopLevel());
      SP<Action> result = dynamic_cast <Action *> (&*carc->getRSV()->makeIt ());
      assert (result);
      return result;
    }
    FString typedGetPrettyName (const ConfigureAndRunConfiguration *c) const {
      return FString("Configure and run ")+c->getRSV()->unParse();
    }
  };
  bool useless = (FactoryTable::store ("Action", NEW (ConfigureAndRun ())),
		  true);
}
