// Fungimol - an extensible system for designing atomic-scale objects.
// Copyright (C) 2000 Tim Freeman
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library in the file COPYING.txt; if not,
// write to the Free Software Foundation, Inc., 59 Temple Place -
// Suite 330, Boston, MA 02111-1307, USA
//
// The author can be reached by email at tim@fungible.com, or by
// paper mail at:
//
// Tim Freeman
// 381 North Fernwood Circle
// Sunnyvale, CA 94085-3059
//

#ifndef MemoryUtil_h_included
#include "MemoryUtil.h"
#endif

#ifndef ActionConfiguration_h_included
#include "ActionConfiguration.h"
#endif

#ifndef Configurable_h_included
#include "Configurable.h"
#endif

#ifndef myassert_h_included
#include "myassert.h"
#endif

#ifndef iostream_h_included
#include <iostream>
#define iostream_h_included
#endif

#ifndef FFloat_h_included
#include "FFloat.h"
#endif

#ifndef Dynavec_h_included
#include "Dynavec.h"
#endif

#ifndef Action_h_included
#include "Action.h"
#endif

#ifndef Factory_h_included
#include "Factory.h"
#endif

#ifndef FString_h_included
#include "FString.h"
#endif

#ifndef TopLevel_h_included
#include "TopLevel.h"
#endif

#ifndef FactoryTable_h_included
#include "FactoryTable.h"
#endif

#ifndef Event_h_included
#include "Event.h"
#endif

namespace {
  // Report all joystick events we are given.
  class Motion
    : public Factory
  {
  public:
    Motion ()
      : Factory ("Motion")
    {}
    SP<Configuration> defaultConfiguration () const {
      return NEW (ActionConfiguration ());
    }
    SP<Configurable> makeIt (const SP<Configuration> c) const {
      SP<ActionConfiguration> conf =
	dynamic_cast <ActionConfiguration *> (&*c);
      assert (conf);
      SP<const Event> e = conf->getTopLevel()->getEvent();
      std::cout << *e << std::endl;
      // No errors possible.
      return NEW (Action ());
    }
  };
  static const bool useless =
  (FactoryTable::store ("Action", NEW (Motion ())),
   true);
};
