// Fungimol - an extensible system for designing atomic-scale objects.
// Copyright (C) 2000 Tim Freeman
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library in the file COPYING.txt; if not,
// write to the Free Software Foundation, Inc., 59 Temple Place -
// Suite 330, Boston, MA 02111-1307, USA
//
// The author can be reached by email at tim@fungible.com, or by
// paper mail at:
//
// Tim Freeman
// 381 North Fernwood Circle
// Sunnyvale, CA 94085-3059
//

#ifndef ColorSlotValue_h_included
#define ColorSlotValue_h_included

#ifndef SlotValue_h_included
#include "SlotValue.h"
#endif

#ifndef Color_h_included
#include "Color.h"
#endif

#ifndef Configuration_h_included
#include "Configuration.h"
#endif

class ColorSlotValue : public SlotValue {
  Color m_value;
protected:
  ColorSlotValue (const ColorSlotValue &csv);
public:
  ColorSlotValue (const Color &m);
  ColorSlotValue (FFloat r, FFloat g, FFloat b, FFloat a);
  Color getValue () const;
  FString unParse () const;
  bool hasTheSameTypeAs (const SlotValue *) const;
  void editSlotValue ();
  SP<SlotValue> copy () const;
  static void setSlot (SP<Configuration> conf, const FString &name,
			const Color &value);
  static Color getSlot (SP<const Configuration> conf, const FString &name);
};
#endif
