// Fungimol - an extensible system for designing atomic-scale objects.
// Copyright (C) 2000 Tim Freeman
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library in the file COPYING.txt; if not,
// write to the Free Software Foundation, Inc., 59 Temple Place -
// Suite 330, Boston, MA 02111-1307, USA
//
// The author can be reached by email at tim@fungible.com, or by
// paper mail at:
//
// Tim Freeman
// 381 North Fernwood Circle
// Sunnyvale, CA 94085-3059
//

#ifndef BouncingBallConfiguration_h_included
#define BouncingBallConfiguration_h_included

#ifndef FFloat_h_included
#include "FFloat.h"
#endif

#ifndef BallConfiguration_h_included
#include "BallConfiguration.h"
#endif

#ifndef SP_h_included
#include "SP.h"
#endif

class Configuration;

class BouncingBallConfiguration: public BallConfiguration {
  FFloat m_gravity;
  FFloat m_mass;
  FFloat m_stiffness;
 public:
  // Turn up this number to slow down the physics.
  static const FFloat timescale;
  BouncingBallConfiguration ();
  void setGravity (FFloat gravity);
  FFloat getGravity () const;
  void setMass (FFloat mass);
  FFloat getMass () const;
  void setStiffness (FFloat stiffness);
  FFloat getStiffness () const;
  bool getRandomVelocities () const;
  void setRandomVelocities (bool b);
  SP<Configuration> copy () const;
  bool hasTheSameTypeAs (const Configuration *c) const;
};

#endif
