// Fungimol - an extensible system for designing atomic-scale objects.
// Copyright (C) 2000 Tim Freeman
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library in the file COPYING.txt; if not,
// write to the Free Software Foundation, Inc., 59 Temple Place -
// Suite 330, Boston, MA 02111-1307, USA
//
// The author can be reached by email at tim@fungible.com, or by
// paper mail at:
//
// Tim Freeman
// 381 North Fernwood Circle
// Sunnyvale, CA 94085-3059
//

#ifndef ObjectDrawer_h_included
#include "ObjectDrawer.h"
#endif

#ifndef BoundingSphere_h_included
#include "BoundingSphere.h"
#endif

#ifndef FFloat_h_included
#include "FFloat.h"
#endif

#ifndef BoundingBox_h_included
#include "BoundingBox.h"
#endif

BoundingSphere ObjectDrawer::graphicsBoundingSphere (const FFloat *state,
						     int objectIndex,
						     const SceneGraph *sg)
  const
{
  (void) objectIndex; (void) sg;
  return BoundingSphere (graphicsBoundingSphereRadius(objectIndex, sg),
			 boundingSphereCenter (state));
}

BoundingSphere ObjectDrawer::selectionBoundingSphere (const FFloat *state,
						      int objectIndex,
						      const SceneGraph *sg)
  const
{
  return graphicsBoundingSphere (state, objectIndex, sg);
}

BoundingBox ObjectDrawer::graphicsBoundingBox (const FFloat *state,
					       int objectIndex,
					       const SceneGraph *sg) const {
  return BoundingBox (graphicsBoundingSphere (state, objectIndex, sg));
}

