# This is a perl script, but we invoke it with perl explicitly, so
# no #! line.

# Write the spec file for fungimol's rpm.
# Following the maximum-rpm.ps document.

$version = $ARGV[0]
    || die "A version number must be specified on the command line";

$dochome = $ARGV[1]
    || die "The document home must be specified as the second argument.";

$installhome = $ARGV[2]
    || die "The installation home must be specified as the third argument.";

$includehome = $ARGV[3]
    || die "The include home must be specified as the fourth argument.";

$splinehome = $ARGV[4]
    || die "The spline data file home must be specified ".
    "as the fifth argument.";

$pluginhome = $ARGV[5]
    || die "The plugin home must be specified as the sixth argument.";

print << "EOM";
#
# Spec file for fungimol.
#
Summary: An extensible system for designing atomic-scale objects.
Name: fungimol
Version: $version
Release: 0
Copyright: LGPL (GNU Library General Public License)
Group: Applications/Engineering
Source: http://www.fungible.com/fungimol/fungimol-$version.tar.gz
URL: http://www.fungible.com/fungimol/index.html
Packager: Tim Freeman <tim\@fungible.com>
# Don't set this to "/", since otherwise we'll do a "rm -rf /" below.
BuildRoot: /var/tmp/fungimol-buildroot
# Explanations for the BuildRequires:
# We need rpm-build to build anything at all.
# We need netpbm-devel because we statically link in netpbm.
# We need gcc-c++ because we have C++ code.
# We need gcc-g77 because we have Fortran code.
# We have XFree86-devel because we statically link in Xext, which does 
#    the MIT shared memory extension so we can draw spheres faster, I think.
BuildRequires: rpm-build netpbm-devel gcc-c++ gcc-g77 XFree86-devel

%description
The intent is to eventually extend it to be a useful system for
doing molecular nanotechnology design work.  At the moment it can
view PDB files, edit Buckminsterfullerines, and it has a plugin to do
Brenner's molecular dynamics force field.

Donald Brenner's Fortran molecular dynamics package is also included.

%prep
%setup

%build
make fullbuild CPLUSPLUS=g++ 

%install
rm -rf \$RPM_BUILD_ROOT
mkdir \$RPM_BUILD_ROOT
make install

%clean
rm -rf \$RPM_BUILD_ROOT

%files
%doc $dochome
$installhome/fungimol
$includehome
$installhome/brennermd
$splinehome
$pluginhome
EOM
